/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.jcg.springtxndemo.app;

import org.springframework.stereotype.Component;
import com.jcg.springtxndemo.service.SpringTxnDemoSvc;
import java.util.logging.Level;
import java.util.logging.Logger;
import com.jcg.springtxndemo.repo.MyTableRepo;

@Component
public class TxnDemoImpl implements TxnDemo
{
    private static final Logger LOG = 
        Logger.getLogger(TxnDemoImpl.class.getName());
    private final SpringTxnDemoSvc updateSvc;

    public TxnDemoImpl(SpringTxnDemoSvc updateSvc)
    {
        this.updateSvc = updateSvc;
    }

    private void trial(boolean succeed)
    {
        LOG.fine(String.format("Start of demo trial: will %s", succeed ? "SUCCEED" : "FAIL"));
        updateSvc.listDb("Database contents BEFORE:");
        try {
            LOG.info("Begin transactional update");
            updateSvc.demoUpdate(succeed);
            LOG.info("Transaction SUCCEEDED!");
        } catch (Exception ex) {
            LOG.log(Level.FINE, "Transaction failed", ex);
        }
        updateSvc.listDb("Database contents AFTER:");
        LOG.fine("End of demo trial");
    }

    @Override
    public void demoTransactions()
    {
        updateSvc.loadDb();
        LOG.info("The first trial will simulate a failure partway through...");
        trial(false);
        LOG.info("The database is UNCHANGED following the failure");
        LOG.info("The second trial will complete successfully...");
        trial(true);
        LOG.info("The database has been updated successfully.");
    }

}
