/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.jcg.springtxndemo.main;

import javax.sql.DataSource;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.convert.ConversionService;
import org.springframework.core.convert.support.DefaultConversionService;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseBuilder;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseType;
import org.springframework.orm.jpa.LocalContainerEntityManagerFactoryBean;
import org.springframework.orm.jpa.vendor.HibernateJpaVendorAdapter;

@Configuration
@ComponentScan(basePackageClasses = {
    com.jcg.springtxndemo.repo.packageInfo.class,
    com.jcg.springtxndemo.app.packageInfo.class,
    com.jcg.springtxndemo.service.packageInfo.class})
@EnableJpaRepositories("com.jcg.springtxndemo.repo")
public class AppConfig
{
    // Has to be "entityManagerFactory" for Spring Data Jpa
    @Bean
    LocalContainerEntityManagerFactoryBean entityManagerFactory()
    {
        HibernateJpaVendorAdapter vendorAdapter = 
            new HibernateJpaVendorAdapter();
        vendorAdapter.setGenerateDdl(true);
       
        LocalContainerEntityManagerFactoryBean cmf =
            new LocalContainerEntityManagerFactoryBean();
        cmf.setDataSource(dataSource());
        cmf.setJpaVendorAdapter(vendorAdapter);
        return cmf;
    }

    @Bean
    DataSource dataSource()
    {
        EmbeddedDatabaseBuilder builder = new EmbeddedDatabaseBuilder();
        return builder
            .setName("MyDb")
            .setType(EmbeddedDatabaseType.H2)
            .build();
    }

    @Bean(name = "conversionService")
    ConversionService conversionSvc()
    {
        return new DefaultConversionService();
    }
}
