/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.jcg.springtxndemo.service;

import com.jcg.springtxndemo.app.TxnDemoImpl;
import com.jcg.springtxndemo.entity.MyTable;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.jcg.springtxndemo.repo.MyTableRepo;
import java.util.logging.Logger;

@Service
public class SpringTxnDemoSvcImpl implements SpringTxnDemoSvc
{
    private static final Logger LOG = 
        Logger.getLogger(SpringTxnDemoSvcImpl.class.getName());
    private final MyTableRepo ftRepo;

    @Autowired
    public SpringTxnDemoSvcImpl(MyTableRepo ftRepo)
    {
        this.ftRepo = ftRepo;
    }

    @Override
    @Transactional
    public void loadDb()
    {
        MyTable mt;

        mt = new MyTable();
        mt.setId(100);
        mt.setName("One hundred");
        ftRepo.save(mt);

        mt = new MyTable();
        mt.setId(200);
        mt.setName("Two hundred");
        ftRepo.save(mt);

        mt = new MyTable();
        mt.setId(300);
        mt.setName("Three hundred");
        ftRepo.save(mt);
    }

    @Override
    @Transactional
    public void demoUpdate(boolean succeed)
    {
        int count = 0;
        for (MyTable mt : ftRepo.findAll()) {
            String newName = mt.getName() + " one";
            LOG.info(String.format("Changing \"%s\" to \"%s\"", mt.getName(), newName));
             mt.setName(newName);
            ftRepo.save(mt);
            ++count;
            if (!succeed && count >= 2) {
                RuntimeException ex = new RuntimeException("OOPS! Something bad happened!");
                LOG.throwing(getClass().getName(), "demoUpdate", ex);
                throw ex;
            }
        }
    }

    @Override
    @Transactional(readOnly = true)
    public void listDb(String header)
    {
        StringBuilder sb = new StringBuilder();
        sb.append(header).append('\n');
        for (MyTable mt : ftRepo.findAll()) {
            sb.append(mt.toString()).append('\n');
        }
        LOG.info(sb.toString());
    }
}
